//*****************************************************//
//
// Unit: RsEdit.cpp
//
// Purpose: Base class for Float and Int edit components
//
// Inherits From: TEdit
//
// Project: RapidMisc
//
// Author: Jeff Hiscock -- jhiscock@rapidsi.com
//
// Date: March 2000
//
// Revisions
//
// Copyright Rapid Systems 2000
//******************************************************//
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "RsEdit.h"
#pragma package(smart_init)
//---------------------------------------------------------------------------
// ValidCtrCheck is used to assure that the components created do not have
// any pure virtual functions.
//

static inline void ValidCtrCheck(TRsEdit *)
{
        new TRsEdit(NULL);
}
//---------------------------------------------------------------------------
__fastcall TRsEdit::TRsEdit(TComponent* Owner)
        : TEdit(Owner)
{
}
//---------------------------------------------------------------------------
namespace Rsedit
{
        void __fastcall PACKAGE Register()
        {
                 TComponentClass classes[1] = {__classid(TRsEdit)};
                 RegisterNoIcon(classes, 0);
        }
}
//---------------------------------------------------------------------------
bool __fastcall TRsEdit::IsNumber(char Key)
{
    bool ok;
    //TODO: Add your source code here
    if (Key >=48 && Key <=57)
       ok = true;
    else
       ok = false;

    return ok;
}


bool __fastcall TRsEdit::IsTabOrReturn(char Key)
{
    bool ok;

    //TODO: Add your source code here
    if (Key == 9 || Key==13 || Key==8)
      ok=true;
    else
      ok=false;

    return ok;

}




bool __fastcall TRsEdit::CheckRange()
{
    //TODO: Add your source code here
    bool ok=true;

    if ( !FMaxValue && !FMinValue)
       return ok;

    FRangeCheck.Min = FMinValue;
    FRangeCheck.Max = FMaxValue;

    if ( FRangeCheck.IsOverMax(CheckValue))
    {
        if (FOnOverMax)
          FOnOverMax(this);
        ok=false;
    }
    else if (FRangeCheck.IsBelowMin(CheckValue))
    {
        if (FOnBelowMin)
          FOnBelowMin(this);

        ok = false;
    }

    return ok;



}


void __fastcall TRsEdit::DoExit(void)
{
    if (FCheckOnExit)
    {
        if (CheckRange())
           TEdit::DoExit();
    }
    else
       TEdit::DoExit();

}


long __fastcall TRsEdit::GetCheckValue()
{
   return 0;

}

void __fastcall TRsEdit::KeyPress(char &Key)
{
   bool ok = true;

   if ( ! IsNumber(Key))
   {

      if (! IsTabOrReturn(Key))
         ok = false;

   }

   if (!ok)
     Key = 0;


}
